<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ReverseCodeDialog xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.dialog;
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> java.util.LinkedList;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.IDialogSettings;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.InputDialog;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.Activator;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.preference.ReversePreference;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.umlparser.CreationPackageCatalog;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Combo;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Control;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <em class="jxr_javadoccomment"> * @author dumoulin</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a> <strong class="jxr_keyword">extends</strong> InputDialog {
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  	<em class="jxr_javadoccomment">/** Internal dialog to show list of searchpaths */</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  	<strong class="jxr_keyword">private</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/InputListDialog.html">InputListDialog</a> listDialog;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  	<em class="jxr_javadoccomment">/** Internal dialog to show list of creation paths */</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  	<strong class="jxr_keyword">private</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/InputListDialog.html">InputListDialog</a> creationPathsDialog;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  	<em class="jxr_javadoccomment">/** Internal selector to select the parser */</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	<strong class="jxr_keyword">private</strong> Combo parserSelectorCombo;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  	
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<em class="jxr_javadoccomment">/** Returned searchpaths */</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">private</strong> String[] searchPath;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<em class="jxr_javadoccomment">/** creationPaths read by the list. One line pattern by element */</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<strong class="jxr_keyword">private</strong> String[] creationPaths;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/** splitted creationPaths. pattern lines are splitted in small path */</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<strong class="jxr_keyword">private</strong> List&lt;String&gt; splittedCreationPaths;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<em class="jxr_javadoccomment">/** Names of available parsers */</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	<strong class="jxr_keyword">private</strong> String[] availableParsers = <strong class="jxr_keyword">new</strong> String[] {<span class="jxr_string">"Default Parser"</span>, <span class="jxr_string">"JavaParser"</span>, <span class="jxr_string">"JDT Parser"</span>};
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<strong class="jxr_keyword">private</strong> String SEARCHPATHS_UID = <span class="jxr_string">":searchpaths"</span>;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">private</strong> String CREATIONPATHS_UID = <span class="jxr_string">":creationpaths"</span>;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String PROJECTNAME_UID = <span class="jxr_string">":projectName"</span>;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SELECTEDPARSER_UID = <span class="jxr_string">":selectedParserIndex"</span>;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	<strong class="jxr_keyword">protected</strong> String MODEL_UID = <span class="jxr_string">"nomodeluid"</span>;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 * then name of the selected project</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">private</strong> String projectName;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 * Returned value indicating the index of the selected parser.</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> selectedParserIndex;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String textMsg = <span class="jxr_string">"Default creation package."</span>;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	@SuppressWarnings(<span class="jxr_string">"unused"</span>)
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String creationPackageTooltips = <span class="jxr_string">"The default creation package is used when no matching creation package are found."</span>;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String dialogTitle = <span class="jxr_string">"Reverse Code"</span>;
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String listMsg = <span class="jxr_string">"search paths  - list of model packages used to search for already existing classes (ex: p1/p2)"</span>;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String listTooltips = <span class="jxr_string">"search paths  - list of model packages used to search for already existing classes (ex: p1/p2)"</span>;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String creationPathMsg = <span class="jxr_string">"creation paths \n"</span>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			+ <span class="jxr_string">"pattern: includePath ; excludePath ; destination (use ';' as separator)\n"</span>;
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String creationPathTooltips = <span class="jxr_string">"creation paths  - list of path describing the models inside which reversed classes will be generated.\n"</span>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			+ <span class="jxr_string">"pattern: includeJavaPackage ; excludeJavaPackage ; destinationPath (use ';' as separator)\n"</span>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			+ <span class="jxr_string">"includeJavaPackage: the java package that should be mapped. Can contain a '*'.\n"</span>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			+ <span class="jxr_string">"excludeJavaPackage: the java package that should be excluded. Can contain a '*'.\n"</span>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			+ <span class="jxr_string">"destinationPath: the uml model inside which matching java packages will be created. Can contain a '*'.\n"</span>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			+ <span class="jxr_string">"if destinationPath contains a '*', it will be replaced by the partname found at the place of '*'\n"</span>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			+ <span class="jxr_string">"in the includeJavaPackage\n"</span>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			+ <span class="jxr_string">"\n"</span>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			+ <span class="jxr_string">"ex: eclipse.org.* ; eclipse.org.papyrus ; *"</span>;
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @param parentShell</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 * @param modelUid UID used to identify preferences storage. Must be linked to the model.</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 * @param projectName</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 * @param searchPathsInitialValues</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a>(Shell parentShell, String modelUid, String projectName, List&lt;String&gt; searchPathsInitialValues) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">super</strong>(parentShell, dialogTitle, textMsg, getInitialValue(modelUid, projectName), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<em class="jxr_comment">// TODO Auto-generated constructor stub</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		IDialogSettings settings = Activator.getDefault().getDialogSettings();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		MODEL_UID = modelUid;
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">this</strong>.projectName = projectName;
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// Look for generationPackageName if none is provided.</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<em class="jxr_comment">// if(initialValue == null)</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<em class="jxr_comment">// {</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<em class="jxr_comment">// String generationPackageName = settings.get("generationPackageName");</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<em class="jxr_comment">// getText().setText(generationPackageName);</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		<em class="jxr_comment">// Find default values for search path and creation path</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		ReversePreference preference = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/preference/ReversePreference.html">ReversePreference</a>();
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		<strong class="jxr_keyword">if</strong> (searchPathsInitialValues == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 			String[] savedSearchPath = settings.getArray( getRootSettingKey() + SEARCHPATHS_UID);
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			<strong class="jxr_keyword">if</strong> (savedSearchPath != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				searchPathsInitialValues = Arrays.asList(savedSearchPath);
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			} <strong class="jxr_keyword">else</strong>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 			{
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				searchPathsInitialValues = getDefaultSearchPath(preference);
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		}
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		<em class="jxr_comment">// Look for saved creationPaths if none is provided.</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<strong class="jxr_keyword">if</strong> (creationPaths == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			String[] savedSearchPath = settings.getArray( getRootSettingKey() + CREATIONPATHS_UID);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 			<strong class="jxr_keyword">if</strong>(savedSearchPath != <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 				creationPaths = savedSearchPath;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			<strong class="jxr_keyword">else</strong>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 				creationPaths = getDefaultCreationPath(preference);
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		<em class="jxr_comment">// Look for saved creationPaths if none is provided.</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		<strong class="jxr_keyword">if</strong>(creationPaths == <strong class="jxr_keyword">null</strong> ) {
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			String[] savedSearchPath = settings.getArray( getRootSettingKey() + CREATIONPATHS_UID);
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 			<strong class="jxr_keyword">if</strong> (savedSearchPath != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 				creationPaths = savedSearchPath;
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 				creationPaths = CreationPackageCatalog.getDefaultPackageCreationPatterns(<span class="jxr_string">" ; "</span>);
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			}
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		listDialog = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/InputListDialog.html">InputListDialog</a>(listMsg, searchPathsInitialValues);
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		listDialog.setTooltips(listTooltips);
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		creationPathsDialog = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/InputListDialog.html">InputListDialog</a>(creationPathMsg, Arrays.asList(creationPaths));
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		creationPathsDialog.setTooltips(creationPathTooltips);
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		<em class="jxr_comment">// Selected parser</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			selectedParserIndex = settings.getInt(getRootSettingKey() + SELECTEDPARSER_UID);
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		} <strong class="jxr_keyword">catch</strong> (NumberFormatException e) {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			<em class="jxr_comment">// Use default parser</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			selectedParserIndex = 0;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 * @return the root of the setting key</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 	<strong class="jxr_keyword">private</strong> String getRootSettingKey() {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		<strong class="jxr_keyword">return</strong> MODEL_UID + projectName;
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 	}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 * @param preference</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 *        the eclipse preferences</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">	 * @return default values of SearchPath from eclipse preferences</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 	<strong class="jxr_keyword">private</strong> List&lt;String&gt; getDefaultSearchPath(<a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/preference/ReversePreference.html">ReversePreference</a> preference) {
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		String[] defaultSearchPath = preference.getSearchPath();
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		LinkedList&lt;String&gt; listSearchPath = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		<strong class="jxr_keyword">for</strong>(String path : defaultSearchPath) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 			listSearchPath.add(path);
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		<strong class="jxr_keyword">return</strong> listSearchPath;
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 * @param preference</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 *        the eclipse preferences</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * @return default values of CreationPath from eclipse preferences</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 	<strong class="jxr_keyword">private</strong> String[] getDefaultCreationPath(<a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/preference/ReversePreference.html">ReversePreference</a> preference) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		String[] defaultCreationPath = preference.getCreationPath();
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">return</strong> defaultCreationPath;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 * @param modelUid</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 * @param projectName</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 *        the name of the reversed project</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 * @return initialValue contained into setting, or &lt;code&gt;projectName&lt;/code&gt; if it doesn't exists</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String getInitialValue(String modelUid, String projectName) {
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		IDialogSettings settings = Activator.getDefault().getDialogSettings();
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		<em class="jxr_comment">// Look for generationPackageName</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		String generationPackageName = settings.get(modelUid + projectName + PROJECTNAME_UID);
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		<strong class="jxr_keyword">if</strong>(generationPackageName != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			<strong class="jxr_keyword">return</strong> generationPackageName;
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 		}
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		<strong class="jxr_keyword">return</strong> projectName;
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 	}
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> <em class="jxr_javadoccomment">	 * Allows resizing.</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 	@Override
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> isResizable() {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 		<em class="jxr_comment">// TODO Auto-generated method stub</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 	}
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 * Get the returned searchpaths.</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 	<strong class="jxr_keyword">public</strong> String[] getSearchPath() {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<strong class="jxr_keyword">return</strong> searchPath;
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 	}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> <em class="jxr_javadoccomment">	 * Get the returned creationPaths, one pattern for each entry, separated by ';'.</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	<strong class="jxr_keyword">public</strong> List&lt;String&gt; getCreationPaths() {
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		<strong class="jxr_keyword">return</strong> splittedCreationPaths;
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 	}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 * Get the index of the selected Parser. </em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 * @return the index of the selected parser, or -1 if none is selected.</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getSelectedParserIndex() {
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		<strong class="jxr_keyword">return</strong> selectedParserIndex;
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 	}
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_javadoccomment">	 * Create additional list of searchpaths.</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 	@Override
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 	<strong class="jxr_keyword">protected</strong> Control createDialogArea(Composite parent) {
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 		
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		IDialogSettings settings = Activator.getDefault().getDialogSettings();
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 		<em class="jxr_comment">// create composite</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		Composite composite = (Composite) <strong class="jxr_keyword">super</strong>.createDialogArea(parent);
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 		listDialog.createDialogArea(composite);
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 		creationPathsDialog.createDialogArea(composite);
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 		
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		<em class="jxr_comment">// Create dropdown allowing to choose the parser</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 		parserSelectorCombo = <strong class="jxr_keyword">new</strong> Combo (composite, SWT.READ_ONLY);
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		parserSelectorCombo.setItems(availableParsers);
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 		parserSelectorCombo.select(selectedParserIndex);
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 				
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 		<strong class="jxr_keyword">return</strong> composite;
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 	}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L275" href="#L275">275</a> <em class="jxr_javadoccomment">	 * Save the searchpath after the button is pressed.</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 	@Override
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> okPressed() {
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 		<em class="jxr_comment">// Save the list before the control is disposed</em>
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		searchPath = listDialog.getList();
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 		creationPaths = creationPathsDialog.getList();
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 		String defaultCreationPath = getValue();
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		<strong class="jxr_keyword">if</strong> (defaultCreationPath == <strong class="jxr_keyword">null</strong> || defaultCreationPath.length() == 0) {
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			defaultCreationPath = CreationPackageCatalog.getDefaultCreationPath();
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 		}
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		<em class="jxr_comment">// Check inputs</em>
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 			<em class="jxr_comment">// Check paths</em>
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 			splittedCreationPaths = computeCreationPaths(creationPaths);
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 			CreationPackageCatalog.validateCreationPath(splittedCreationPaths);
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 			<em class="jxr_comment">// add default searchPaths</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 			searchPath = addDefaultSearchPaths(Arrays.asList(searchPath), splittedCreationPaths).toArray(<strong class="jxr_keyword">new</strong> String[0]);
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 		} <strong class="jxr_keyword">catch</strong> (Exception e) {
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 			<em class="jxr_comment">// TODO Auto-generated catch block</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 			showError(e.getMessage());
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 		}
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 		
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 		<em class="jxr_comment">// Get selected parser</em>
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 		selectedParserIndex = parserSelectorCombo.getSelectionIndex();
<a class="jxr_linenumber" name="L303" href="#L303">303</a>  
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 		
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 		<em class="jxr_comment">// save values</em>
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 		IDialogSettings settings = Activator.getDefault().getDialogSettings();
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		settings.put(getRootSettingKey() + SEARCHPATHS_UID, searchPath);
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 		settings.put(getRootSettingKey() + CREATIONPATHS_UID, creationPaths);
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 		settings.put(getRootSettingKey() + PROJECTNAME_UID, getValue());
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 		settings.put(getRootSettingKey() + SELECTEDPARSER_UID, selectedParserIndex);
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 		<strong class="jxr_keyword">super</strong>.okPressed();
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 	}
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L317" href="#L317">317</a> <em class="jxr_javadoccomment">	 * Add the defaultSearchPath extracted from the splittedCreationPath to the searchPath.</em>
<a class="jxr_linenumber" name="L318" href="#L318">318</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L319" href="#L319">319</a> <em class="jxr_javadoccomment">	 * @param splittedCreationPaths2</em>
<a class="jxr_linenumber" name="L320" href="#L320">320</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 	<strong class="jxr_keyword">private</strong> List&lt;String&gt; addDefaultSearchPaths(List&lt;String&gt; searchPath, List&lt;String&gt; splittedCreationPaths) {
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 		List&lt;String&gt; result = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;(searchPath.size() + splittedCreationPaths.size());
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 		result.addAll(searchPath);
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		List&lt;String&gt; additionalPaths = CreationPackageCatalog.extractCreationPaths(splittedCreationPaths.toArray(<strong class="jxr_keyword">new</strong> String[0]));
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 		<strong class="jxr_keyword">for</strong> (String toAdd : additionalPaths) {
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 			<strong class="jxr_keyword">if</strong> (!result.contains(toAdd)) {
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 				result.add(toAdd);
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 			}
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		}
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 		<strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 	}
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L338" href="#L338">338</a> <em class="jxr_javadoccomment">	 * Show an error message</em>
<a class="jxr_linenumber" name="L339" href="#L339">339</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L340" href="#L340">340</a> <em class="jxr_javadoccomment">	 * @param message</em>
<a class="jxr_linenumber" name="L341" href="#L341">341</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> showError(String message) {
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		System.err.println(<span class="jxr_string">"Error: "</span> + message);
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 	}
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L349" href="#L349">349</a> <em class="jxr_javadoccomment">	 * Compute and check the creationsPaths</em>
<a class="jxr_linenumber" name="L350" href="#L350">350</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L351" href="#L351">351</a> <em class="jxr_javadoccomment">	 * @param creationPaths</em>
<a class="jxr_linenumber" name="L352" href="#L352">352</a> <em class="jxr_javadoccomment">	 *            An array with one creationPattern by element</em>
<a class="jxr_linenumber" name="L353" href="#L353">353</a> <em class="jxr_javadoccomment">	 * @return An array with one path by elements</em>
<a class="jxr_linenumber" name="L354" href="#L354">354</a> <em class="jxr_javadoccomment">	 * @throws Exception</em>
<a class="jxr_linenumber" name="L355" href="#L355">355</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 	<strong class="jxr_keyword">private</strong> List&lt;String&gt; computeCreationPaths(String[] creationPaths) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 		List&lt;String&gt; result = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 		<em class="jxr_comment">// Iterate line by line</em>
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 		<em class="jxr_comment">// For each line, separate the 3 patterns</em>
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 		<em class="jxr_comment">// If a pattern is empty, put a null</em>
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 		<strong class="jxr_keyword">for</strong> (String line : creationPaths) {
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 			String[] eles = line.split(<span class="jxr_string">";"</span>);
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 			<strong class="jxr_keyword">if</strong> (eles.length != 3) {
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> Exception(<span class="jxr_string">"A line must contains 3 pattern separated by ';' :"</span> + line);
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 			}
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 			<strong class="jxr_keyword">for</strong> (String ele : eles)
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 			{
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 				ele = ele.trim();
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 				<strong class="jxr_keyword">if</strong> (ele.length() == 0) {
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 					ele = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 				}
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 				<em class="jxr_comment">// add ele</em>
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 				result.add(ele);
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 			}
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 		}
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 		<strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 	}
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 
<a class="jxr_linenumber" name="L382" href="#L382">382</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
